-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local LJDSpellInterrupt_default = {
        ["ShowPrintDebugMsg"] = true,
        ["ShowNameplateName"] = false,
        ["ShowSkillId"]=false,
        ["CenterSkillButton"] = true,
        ["MoveAbleInterfaceOptionsFrame"] = true,
        ["ICON_SIZE"] = 25,
        ["ICON_WIDTH"] = 25,
        ["ICON_HEIGHT"] = 25,
        ["NumberLimitSpecialBuff"] = 10,
        ["NumberLimitSpecialDeBuff"] = 10,
        ["MilliSecondNameplateUpdateDoration"]=155,
        ["HideCountdownNumbers"] = true,
        ["ShowSpecialBuff"]= true,
        ["ShowSpecialBuffTooltip"]= true,
        ["ShowSpecialDeBuff"]= true,
        ["ShowSpecialDeBuffTooltip"]= true,
        ["ShowPlayerBigBuff"]= true,
        ["ReLocateGameToolTip"]= true,
        ["ShowFriendsSpecialBuff"]=true,
        ["ShowFriendsSpecialDeBuff"]=true,
        ["ShowCoordinate"]=true,
        ["ShowOnlyPlayerDeBuff"]=false,
        ["ShowCastingBar"]=true,
        ["ShowCastingTooltip"]=true,
        ["AutoHideCastingTooltip"]=true,
        ["ShowRaidTargetMarker"]=true,
        ["ShowWorldMarker"]=true,
}
local LJDSpellInterrupt_chr_default = {
}

local LJDConfigUI = {
};
--local addonName = "LJDSpellInterrupt"; -- 어짜피 내 애드온명이 넘오온다.


-- 20191129
-- 단축키 설정창에 LJDSpellInterrupt 추가하기
-- Keybindings
-- 기본키 : 컨트롤 - 시프트 - 엔터
BINDING_HEADER_LJDSpellInterrupt = L["이진득's 스킬차단 알림"];
BINDING_NAME_LJDSpellInterrupt_ON = L["설정 열기"];
local LJDSpellInterrupt_ON_Default_KEY = "CTRL-SHIFT-ENTER";    -- reload시 단축키가 없어져서 AddonLoad 될때마다 없으면 재지정.

SLASH_LJD1 = "/jd";
SLASH_LJD2 = "/ㅓㅇ";
SlashCmdList.LJD = function()
    --print("OpenLJDOption");
    OpenLJDOption();
end

local LJDConfig = CreateFrame("Frame");
LJDConfig:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function LJDConfig:ADDON_LOADED(_, argAddonName)
    --print(argAddonName, addonName);
    if argAddonName ~= addonName then return end;

    if LJDSpellInterruptDB == nil then
        LJDSpellInterruptDB = LJDSpellInterrupt_default;
    else
        SetDefaultEmptyDBValue();
    end

    if (LJDSpellInterruptDBChr ~= nil) and type(LJDSpellInterruptDBChr) == "number" then
        local name, elapsed = UnitName("player"), time() - LJDSpellInterruptDBChr;
        print("Hello again, " .. name .. "; you've been gone for " .. SecondsToTime(elapsed) .. ".");
    end

    -- 인터페이스옵션에 추가
    LJDConfigUI:createLJDInterfaceOption();

    -- 이동가능한 윈도우로 변경
    if LJDSpellInterruptDB["MoveAbleInterfaceOptionsFrame"] then
        ChangeMoveableFrame(InterfaceOptionsFrame); -- 인터페이스옵션
        ChangeMoveableFrame(WorldMapFrame); -- 지도
        ChangeMoveableFrame(SpellBookFrame); -- 스킬창

        --ChangeMoveableFrame(PlayerTalentFrame); -- 전문화창
        --PlayerTalentFrameSpecialization:show();
    end;

    -- 단축키 확인 및 재지정.
    -- (다른 애드온이 해당 단축키를 선점하고 있으면 PASS)
	local ExistingBinding = GetBindingAction(LJDSpellInterrupt_ON_Default_KEY, true);
	if not ExistingBinding or ExistingBinding == "" then
		SetBinding(LJDSpellInterrupt_ON_Default_KEY, "LJDSpellInterrupt_ON");
	end

    print(addonName.." Load complite !!");

end
LJDConfig:RegisterEvent("ADDON_LOADED");

function LJDConfig:PLAYER_LOGOUT(...)
    -- Save 케릭터별 DB : logout time
    LJDSpellInterruptDBChr = time();
end
LJDConfig:RegisterEvent("PLAYER_LOGOUT");

function SetDefaultEmptyDBValue()
    -- Save 애드온별 DB : Default 값에 없는 값이있으면 변수추가
    --LJDSpellInterruptDB
    local tempDB = LJDSpellInterrupt_default; -- Default 깔고
    for i,v in next, LJDSpellInterrupt_default do
         -- DB에 있는값만 덮어쓰기
        if(LJDSpellInterruptDB[i] ~= nil) then tempDB[i] = LJDSpellInterruptDB[i]; end;
    end
    --LJDSpellInterruptDB = {};
    LJDSpellInterruptDB = tempDB;
end

function OpenLJDOption()
    if not LJDConfigUI["OptionPanelPointer"] then
        LJDConfigUI["OptionPanelPointer"] = LJDConfigUI:createLJDOption();
    end;
    LJDConfigUI["OptionPanelPointer"]:SetShown(not LJDConfigUI["OptionPanelPointer"]:IsShown());
end

function UIConfig_CheckbntClick(self)

    --print(self.key, self:GetChecked());
    --print(this["key"], this:GetChecked()); ==> Error : "this" 없음

    -- 체크버튼 선택에 따른 설정변수 갱신
    LJDSpellInterruptDB[self.key] = self:GetChecked();

    -- 설정변경에 따른 전체 다시 그리기
    UIConfig_ReDrawAll(self.key);

end

-- 설정변경에 따른 전체 다시 그리기
function UIConfig_ReDrawAll(strChangedKey)

    -- 20191216 중앙버튼정렬 변경시에만 재정렬
    if( strChangedKey == "CenterSkillButton" ) then
        -- 중앙버튼
        LJDSpellInterrupt_CenterButton();
    end

    -- 전체UnitFrame 갱신
    for _,baseFrame in pairs(C_NamePlate.GetNamePlates()) do
        --print(baseFrame.unit)
        --
        LJDNameplate_Aura_update(baseFrame.UnitFrame);
    end
    
    if( strChangedKey == "ShowRaidTargetMarker" or strChangedKey == "ShowWorldMarker" ) then
        LJDWorldMarker_ReDraw();
    end
end


-- 체크버튼 생성
local function CreateOptionCheckButton(frame, chkIndex, key, text, tooltipText, tooltipRequirement )

    local checkButtonName = frame:GetName().."CheckButton";

    local chkBtn = CreateFrame("CheckButton", checkButtonName..chkIndex, frame, "OptionsCheckButtonTemplate");
    chkBtn.text = _G[chkBtn:GetName().."Text"]
    chkBtn.text:SetText(text);

    if chkIndex == 1 then
        chkBtn:SetPoint("TOPLEFT", frame, "TOPLEFT", 30, -100);
    elseif( chkIndex == 18 ) then
        chkBtn:SetPoint("TOPLEFT", frame, "TOP", -80, -100);
    else
        chkBtn:SetPoint("TOPLEFT", _G[checkButtonName..(chkIndex-1)], "BOTTOMLEFT", 0, 0);
    end

    --chkBtn:SetScript("OnClick", UIConfig_CheckbntClick);
    chkBtn:SetScript("OnClick", function(self)
        -- 체크버튼 선택에 따른 설정변수 갱신
        LJDSpellInterruptDB[self.key] = self:GetChecked();
        -- print("LJDSpellInterruptDB[".. self.key .."] : "..tostring(LJDSpellInterruptDB[self.key]));
        -- 설정변경에 따른 전체 다시 그리기
        UIConfig_ReDrawAll(self.key);
    end);

    chkBtn.tooltipText        = tooltipText;                -- 툴팁1
    chkBtn.tooltipRequirement = tooltipRequirement;         -- 툴팁2
    chkBtn.key = key;                                       -- 연결할 SavedVariables 의 key
    chkBtn:SetChecked(LJDSpellInterruptDB[chkBtn.key]);

    frame.chkbtnList[chkIndex] = chkBtn; -- 배열에 저장.

    return chkBtn;
end

-- 슬라이더 생성
local function CreateOptionSlider(frame, sliderIndex, key, lowValue, highValue, tooltipText, tooltipRequirement )

    local sliderName = frame:GetName().."Slider";

    local slider = CreateFrame("Slider", sliderName..sliderIndex, frame, "OptionsSliderTemplate");

    slider:SetValueStep(1);
    slider:SetObeyStepOnDrag(true);
    slider:SetMinMaxValues(lowValue, highValue);
    _G[slider:GetName().."Low"]:SetText(lowValue);
    _G[slider:GetName().."High"]:SetText(highValue);
    _G[slider:GetName().."Text"]:SetText(tooltipText);

    if sliderIndex == 1 then
        slider:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -30, -120);
    else
        slider:SetPoint("TOP", _G[sliderName..(sliderIndex-1).."EditBox"], "BOTTOM", 0, -30);
    end

    slider.tooltipText        = tooltipText;                -- 툴팁1
    slider.tooltipRequirement = tooltipRequirement;         -- 툴팁2
    slider.key = key;                                       -- 연결할 SavedVariables 의 key

    slider.SetDisplayValue = slider.SetValue;
    slider.SetValue = function(self, value)
        self:SetDisplayValue(value);
        if self.valueText then
            -- 현재값 보기위한 texture에 값설정
            self.valueText:SetText(LJDSpellInterruptDB[self.key]);
        end

        -- 설정변경에 따른 전체 다시 그리기
        UIConfig_ReDrawAll(self.key);
    end

    slider:SetValue(LJDSpellInterruptDB[slider.key]);

    -- Slider 값 변경시 처리
    slider:SetScript("OnValueChanged", function(self, value)
        --print("OnValueChanged:"..value);
        LJDSpellInterruptDB[self.key] = value;
        self.value = value;
        self:SetValue(value);

        -- size 가로, 세로 동일변경
        if( slider.key == "ICON_SIZE" ) then
            LJDSpellInterruptDB["ICON_WIDTH"] = value;
            LJDSpellInterruptDB["ICON_HEIGHT"] = value;
        end

        -- (디)버프아이콘 크기변경이면 바로 적용
        if(self.key == "ICON_SIZE" or self.key == "ICON_WIDTH" or self.key == "ICON_HEIGHT") then
            for _,nameplate in pairs(C_NamePlate.GetNamePlates()) do
                for i =1, nameplate.highlightBuffFrame.iconShownCount do
                    nameplate.highlightBuffFrame.icon[i]:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]);
                    nameplate.highlightBuffFrame.icon[i].border:SetSize(LJDSpellInterruptDB["ICON_WIDTH"]+2, LJDSpellInterruptDB["ICON_HEIGHT"]+2);
                    nameplate.highlightBuffFrame.icon[i].countText:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], 10);
                    nameplate.highlightBuffFrame.icon[i].duration:SetTextHeight(math.max(LJDSpellInterruptDB["ICON_WIDTH"]/3, 7));
                end
                for i =1, nameplate.highlightDeBuffFrame.iconShownCount do
                    nameplate.highlightDeBuffFrame.icon[i]:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]);
                    nameplate.highlightDeBuffFrame.icon[i].border:SetSize(LJDSpellInterruptDB["ICON_WIDTH"]+2, LJDSpellInterruptDB["ICON_HEIGHT"]+2);
                    nameplate.highlightDeBuffFrame.icon[i].countText:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], 10);
                    nameplate.highlightDeBuffFrame.icon[i].duration:SetTextHeight(math.max(LJDSpellInterruptDB["ICON_WIDTH"]/3, 7));
                end
            end
        end
        
        -- 버프/디버프 표현 타이머 갱신간격 적용
        if( slider.key == "MilliSecondNameplateUpdateDoration" ) then
            LJDNameplate_StopTimer();
            LJDNameplate_StartTimer();
        end

    end);


    --
    slider.valueText = slider:CreateFontString(slider:GetName().."EditBox", "OVERLAY");
        -- OUTLINE 은 폰트를 굵고 테두리가 표시 되도록하는 옵션이다.
    --slider.valueText:SetFont([[Fonts\2002.TTF]], 15, "OUTLINE");
    slider.valueText:SetFontObject("GameFontNormal");
    slider.valueText:SetTextHeight(14);
    slider.valueText:SetPoint("TOPLEFT", slider, "BOTTOMLEFT");
    slider.valueText:SetPoint("TOPRIGHT", slider, "BOTTOMRIGHT");
    slider.valueText:SetText(LJDSpellInterruptDB[slider.key]);
    slider.valueText:SetJustifyV("TOP");
    slider.valueText:SetJustifyH("CENTER");

    --[[
    local editbox = CreateFrame("EditBox", slider:GetName().."EditBox", frame);
    editbox:SetPoint("TOP", slider, "BOTTOM", 0, -20);
    editbox:SetSize(12, 12);
    editbox:SetFont("Fonts\\ARIALN.TTF", 10, OUTLINE)
    editbox:SetAutoFocus(false)
    editbox:SetTextInsets(12, 12, 0, 4)
    editbox:SetText("1123");
    editbox:SetScript("OnEnterPressed", function(self)
        print("dddd");
        slider:SetValue(editbox:GetText());
    end);
    editbox:Show();
    --]]


    slider:Show();
    frame.sliderList[sliderIndex] = slider; -- 배열에 저장.

    return slider;
end

-- SavedVariables설정변수값으로 컨트롤 재 설정
function LJDConfigUI.SyncVariable(...)
    local ll={...};
    local self = ll[1];
    --DebugPrintTable(ll);

    --OnShow 는 인자없음
    if not self then
        --print("self is nil");
        --return;
    end

    -- CheckButton
    for i=1, #self.chkbtnList do
        self.chkbtnList[i]:SetChecked(LJDSpellInterruptDB[self.chkbtnList[i].key]);
    end

    -- Slider
    for i=1, #self.sliderList do
        self.sliderList[i]:SetValue(LJDSpellInterruptDB[self.sliderList[i].key]);
    end

end


function LJDConfigUI:createLJDOption()

    --UIConfig = CreateFrame("Frame", "LJDOptionFrame", UIParent, "BasicFrameTemplate");
    local UIConfig = CreateFrame("Frame", "LJDOptionFrame", UIParent, "BasicFrameTemplateWithInset");
    --UIConfig = CreateFrame("Frame", "LJDOptionFrame", UIParent, "UIPanelDialogTemplate");
    UIConfig:SetSize(620,570);
    UIConfig:SetPoint("CENTER", UIParent, "CENTER");

    UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY");
    UIConfig.title:SetFontObject("GameFontHighlight");
    UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0);
    UIConfig.title:SetText(addonName.." Option");

--[[
    UIConfig.subtitle = UIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
    UIConfig.subtitle:SetPoint("TOPLEFT", 18, -16);
    UIConfig.subtitle:SetText(addonName);
--]]
    -- 이동가능한 윈도우로 변경
    UIConfig:SetClampedToScreen(true);
    UIConfig:SetMovable(true);
    UIConfig:EnableMouse(true);
    UIConfig:RegisterForDrag("LeftButton");
    UIConfig:SetScript("OnDragStart", UIConfig.StartMoving);
    UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing);

    --Button Reload
    UIConfig.saveButton = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
    UIConfig.saveButton:SetPoint("RIGHT", UIConfig, "TOP", -40, -70);
    UIConfig.saveButton:SetSize(140, 40);
    UIConfig.saveButton:SetText("Reload");
    UIConfig.saveButton:SetNormalFontObject("GameFontNormalLarge");
    UIConfig.saveButton:SetHighlightFontObject("GameFontHighlightLarge");
    --UIConfig.saveButton:SetPushedFontObject("");
    --UIConfig.saveButton:SetDisabledFontObject("");
    UIConfig.saveButton:SetScript ("OnClick", ReloadUI);

    --Button CVar변경
    UIConfig.setCVar = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
    UIConfig.setCVar:SetPoint("LEFT", UIConfig.saveButton, "RIGHT", 0, 0);
    UIConfig.setCVar:SetSize(70, 40);
    UIConfig.setCVar:SetText(L["CVar변경"]);
    UIConfig.setCVar:SetNormalFontObject("GameFontNormalLarge");
    UIConfig.setCVar:SetHighlightFontObject("GameFontHighlightLarge");
    UIConfig.setCVar:SetScript ("OnClick", LJDSetCVarVariables);
    
    --Button CVar복원
    UIConfig.restoreCVar = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
    UIConfig.restoreCVar:SetPoint("LEFT", UIConfig.setCVar, "RIGHT", 0, 0);
    UIConfig.restoreCVar:SetSize(70, 40);
    UIConfig.restoreCVar:SetText(L["CVar복원"]);
    UIConfig.restoreCVar:SetNormalFontObject("GameFontNormalLarge");
    UIConfig.restoreCVar:SetHighlightFontObject("GameFontHighlightLarge");
    UIConfig.restoreCVar:SetScript ("OnClick", LJDRestoreCVarVariables);

    --Button 화면중앙 버튼정렬 위치 초기화
    UIConfig.restoreActionBar = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
    UIConfig.restoreActionBar:SetPoint("LEFT", UIConfig.restoreCVar, "RIGHT", 0, 0);
    UIConfig.restoreActionBar:SetSize(80, 40);
    UIConfig.restoreActionBar:SetText(L["버튼 초기화"]);
    UIConfig.restoreActionBar:SetNormalFontObject("GameFontNormalLarge");
    UIConfig.restoreActionBar:SetHighlightFontObject("GameFontHighlightLarge");
    UIConfig.restoreActionBar:SetScript ("OnClick", LJDResoreActionBar_OnClick);
    UIConfig.restoreActionBar.tooltipText = L["Ctrl-Shift-마우스 좌버튼 드래그로 버튼위치를 변경할수 있습니다.\nCtrl-Shift-마우스 우버튼 드래그로 버튼크기를 변경할수 있습니다.\n위치를 초기화 합니다."];  -- 툴팁

    -- 각종 위젯리스트
    UIConfig.chkbtnList = {};
    UIConfig.sliderList = {};

    --Check
    --
    -- CreateOptionCheckButton(frame, chkIndex, key, text, tooltipText, tooltipRequirement )
    -- 또는
    -- local temp = CreateOptionCheckButton(frame, chkIndex, key, text, tooltipText, tooltipRequirement )
    -- temp.text:SetText("dddd");
    CreateOptionCheckButton(UIConfig, 1, "ShowNameplateName"            , L["nameplate 찾기"        ], L["<UnitFrame의 이름출력>"                                            ], L["디버깅용"]);
    CreateOptionCheckButton(UIConfig, 2, "ShowSkillId"                  , L["스킬ID 보기"           ], L["<스킬ID 보기>"                                                    ], L["디버깅용"]);
    CreateOptionCheckButton(UIConfig, 3, "CenterSkillButton"            , L["화면중앙 버튼 정렬"    ], L["<화면중앙 버튼 정렬>"                                              ], L["사용여부를 선택합니다."]);
    CreateOptionCheckButton(UIConfig, 4, "MoveAbleInterfaceOptionsFrame", L["프레임 이동가능"       ], L["기본Frame의 이동여부를 선택합니다."                                ], L["Ex)인터페이스 설정, 맵"]);
    CreateOptionCheckButton(UIConfig, 5, "ShowSpecialBuff"              , L["버프 표시"             ], L["<이름표 오른쪽버프 Icon 표시>"                                     ], L["사용여부를 선택합니다."]);
    CreateOptionCheckButton(UIConfig, 6, "ShowSpecialBuffTooltip"       , L["버프Tooltip활성화"     ], L["버프위에 마우스를 올렸을때 Tooltip 표시여부를 선택합니다."         ], "");
    CreateOptionCheckButton(UIConfig, 7, "ShowSpecialDeBuff"            , L["디버프 표시"           ], L["<이름표 위쪽 디버프 Icon 표시>"                                    ], L["사용여부를 선택합니다."]);
    CreateOptionCheckButton(UIConfig, 8, "ShowSpecialDeBuffTooltip"     , L["디버프Tooltip활성화"   ], L["디버프위에 마우스를 올렸을때 Tooltip 표시여부를 선택합니다."       ], "");
    CreateOptionCheckButton(UIConfig, 9, "ShowPlayerBigBuff"            , L["플레이어 Big버프표시"  ], L["Player 체력바위에 버프 표시여부를 선택합니다."                     ], "");
    CreateOptionCheckButton(UIConfig,10, "ReLocateGameToolTip"          , L["툴팁위치이동 사용"     ], L["툴팁의 위치를 우측하단에서 우측중앙하단으로 이동할지를 선택합니다."], "");
    CreateOptionCheckButton(UIConfig,11, "ShowFriendsSpecialBuff"       , L["아군 버프 표시여부"    ], L["<아군 버프 표시여부>"                                              ], L["디버깅용"]);
    CreateOptionCheckButton(UIConfig,12, "ShowFriendsSpecialDeBuff"     , L["아군 디버프 표시여부"  ], L["<아군 디버프 표시여부>"                                            ], L["디버깅용"]);
    CreateOptionCheckButton(UIConfig,13, "ShowCoordinate"               , L["좌표보기 표시여부"     ], L["<좌표보기 표시여부>"                                               ], L["Reload 필요"]);
    CreateOptionCheckButton(UIConfig,14, "ShowOnlyPlayerDeBuff"         , L["내 디버프만 보기"      ], L["<내가 건 디버프만 보기여부>"                                       ], L["내가 건 디버프만 보고싶을때 선택합니다."]);
    CreateOptionCheckButton(UIConfig,15, "ShowCastingBar"               , L["캐스팅바 보기"         ], L["<캐스팅바 보기>"                                                   ], L["마우스 오버, 대상의 시전바를 생성합니다."]);
    CreateOptionCheckButton(UIConfig,16, "ShowCastingTooltip"           , L["캐스팅 툴팁 보기"      ], L["<캐스팅 툴팁 보기>"                                                ], L["대상의 캐스팅 스킬의 툴팁을 생성합니다."]);
    CreateOptionCheckButton(UIConfig,17, "AutoHideCastingTooltip"       , L["캐스팅 툴팁 자동숨기기"], L["<캐스팅 툴팁 자동숨기기>"                                          ], L["캐스팅 툴팁이 15초후 사라집니다."]);
    CreateOptionCheckButton(UIConfig,18, "ShowRaidTargetMarker"         , L["타켓 징표 보기"        ], L["타켓 징표 표시여부를 선택합니다."                                  ], "");
    CreateOptionCheckButton(UIConfig,19, "ShowWorldMarker"              , L["바닥 징표 보기"        ], L["바닥 징표 표시여부를 선택합니다."                                  ], "");
    
    
    --Slider
    --CreateOptionSlider(frame, sliderIndex, key, lowValue, highValue, tooltipText, tooltipRequirement )
    CreateOptionSlider(UIConfig, 1, "ICON_SIZE"                         ,   1,   50, L["(디)버프ICON 크기"            ], L["버프 및 디버프 아이콘의 사이즈"] );
    CreateOptionSlider(UIConfig, 2, "NumberLimitSpecialBuff"            ,   1,   20, L["버프 최대ICON 갯수"           ], L["버프 최대ICON 갯수"]);
    CreateOptionSlider(UIConfig, 3, "NumberLimitSpecialDeBuff"          ,   1,   20, L["디버프 최대ICON 갯수"         ], L["디버프 최대ICON 갯수"] );
    CreateOptionSlider(UIConfig, 4, "MilliSecondNameplateUpdateDoration",  10, 1000, L["버프/디버프 갱신 시간간격(ms)"], L["값이 낮을수록 빠르지만, FPS에 영향을 줍니다.\n추천 : 155"] );

    UIConfig:Hide();
    UIConfig:SetScript("OnShow", LJDConfigUI.SyncVariable);

    return UIConfig;
end

function LJDConfigUI:createLJDInterfaceOption()

    --local IFOUIConfig = CreateFrame("Frame", "LJDOptionFrame", UIParent, "BasicFrameTemplateWithInset");
    local IFOUIConfig = CreateFrame("Frame", "LJDIFOptionFrame", UIParent);
    IFOUIConfig.name = addonName;

    IFOUIConfig.title = IFOUIConfig:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
    IFOUIConfig.title:SetPoint("TOPLEFT", 18, -16);
    IFOUIConfig.title:SetText(addonName);

    --Button Reload
    IFOUIConfig.saveButton = CreateFrame("Button", nil, IFOUIConfig, "GameMenuButtonTemplate");
    IFOUIConfig.saveButton:SetPoint("RIGHT", IFOUIConfig, "TOP", -40, -70);
    IFOUIConfig.saveButton:SetSize(140, 40);
    IFOUIConfig.saveButton:SetText("Reload");
    IFOUIConfig.saveButton:SetNormalFontObject("GameFontNormalLarge");
    IFOUIConfig.saveButton:SetHighlightFontObject("GameFontHighlightLarge");
    --IFOUIConfig.saveButton:SetPushedFontObject("");
    --IFOUIConfig.saveButton:SetDisabledFontObject("");
    IFOUIConfig.saveButton:SetScript ("OnClick", ReloadUI);

    --Button CVar변경
    IFOUIConfig.setCVar = CreateFrame("Button", nil, IFOUIConfig, "GameMenuButtonTemplate");
    IFOUIConfig.setCVar:SetPoint("LEFT", IFOUIConfig.saveButton, "RIGHT", 0, 0);
    IFOUIConfig.setCVar:SetSize(70, 40);
    IFOUIConfig.setCVar:SetText(L["CVar변경"]);
    IFOUIConfig.setCVar:SetNormalFontObject("GameFontNormalLarge");
    IFOUIConfig.setCVar:SetHighlightFontObject("GameFontHighlightLarge");
    IFOUIConfig.setCVar:SetScript ("OnClick", LJDSetCVarVariables);
    
    --Button CVar복원
    IFOUIConfig.restoreCVar = CreateFrame("Button", nil, IFOUIConfig, "GameMenuButtonTemplate");
    IFOUIConfig.restoreCVar:SetPoint("LEFT", IFOUIConfig.setCVar, "RIGHT", 0, 0);
    IFOUIConfig.restoreCVar:SetSize(70, 40);
    IFOUIConfig.restoreCVar:SetText(L["CVar복원"]);
    IFOUIConfig.restoreCVar:SetNormalFontObject("GameFontNormalLarge");
    IFOUIConfig.restoreCVar:SetHighlightFontObject("GameFontHighlightLarge");
    IFOUIConfig.restoreCVar:SetScript ("OnClick", LJDRestoreCVarVariables);

    --Button 화면중앙 버튼정렬 위치 초기화
    IFOUIConfig.restoreActionBar = CreateFrame("Button", nil, IFOUIConfig, "GameMenuButtonTemplate");
    IFOUIConfig.restoreActionBar:SetPoint("LEFT", IFOUIConfig.restoreCVar, "RIGHT", 0, 0);
    IFOUIConfig.restoreActionBar:SetSize(80, 40);
    IFOUIConfig.restoreActionBar:SetText(L["버튼 초기화"]);
    IFOUIConfig.restoreActionBar:SetNormalFontObject("GameFontNormalLarge");
    IFOUIConfig.restoreActionBar:SetHighlightFontObject("GameFontHighlightLarge");
    IFOUIConfig.restoreActionBar:SetScript ("OnClick", LJDResoreActionBar_OnClick);
    IFOUIConfig.restoreActionBar.tooltipText = L["Ctrl-Shift-마우스 좌버튼 드래그로 버튼위치를 변경할수 있습니다.\nCtrl-Shift-마우스 우버튼 드래그로 버튼크기를 변경할수 있습니다.\n위치를 초기화 합니다."];  -- 툴팁

    -- 각종 위젯리스트
    IFOUIConfig.chkbtnList = {};
    IFOUIConfig.sliderList = {};
    --Slider
    --[[
    IFOUIConfig.slider1 = CreateFrame("Slider", nil, IFOUIConfig, "OptionsSliderTemplate");
    IFOUIConfig.slider1:SetPoint("TOP", IFOUIConfig.reload, "BOTTOM", 0, -20);
    IFOUIConfig.slider1:SetMinMaxValues(1,100);
    IFOUIConfig.slider1:SetValue(50);
    IFOUIConfig.slider1:SetValueStep(10);
    IFOUIConfig.slider1:SetObeyStepOnDrag(true);
    --]]


    --Check
    --
    -- CreateOptionCheckButton(frame, chkIndex, key, text, tooltipText, tooltipRequirement )
    -- 또는
    -- local temp = CreateOptionCheckButton(frame, chkIndex, key, text, tooltipText, tooltipRequirement )
    -- temp.text:SetText("dddd");
    CreateOptionCheckButton(IFOUIConfig, 1, "ShowNameplateName"            , L["nameplate 찾기"        ], L["<UnitFrame의 이름출력>"                                            ], L["디버깅용"]);
    CreateOptionCheckButton(IFOUIConfig, 2, "ShowSkillId"                  , L["스킬ID 보기"           ], L["<스킬ID 보기>"                                                    ], L["디버깅용"]);
    CreateOptionCheckButton(IFOUIConfig, 3, "CenterSkillButton"            , L["화면중앙 버튼 정렬"    ], L["<화면중앙 버튼 정렬>"                                              ], L["사용여부를 선택합니다."]);
    CreateOptionCheckButton(IFOUIConfig, 4, "MoveAbleInterfaceOptionsFrame", L["프레임 이동가능"       ], L["기본Frame의 이동여부를 선택합니다."                                ], L["Ex)인터페이스 설정, 맵"]);
    CreateOptionCheckButton(IFOUIConfig, 5, "ShowSpecialBuff"              , L["버프 표시"             ], L["<이름표 오른쪽버프 Icon 표시>"                                     ], L["사용여부를 선택합니다."]);
    CreateOptionCheckButton(IFOUIConfig, 6, "ShowSpecialBuffTooltip"       , L["버프Tooltip활성화"     ], L["버프위에 마우스를 올렸을때 Tooltip 표시여부를 선택합니다."         ], "");
    CreateOptionCheckButton(IFOUIConfig, 7, "ShowSpecialDeBuff"            , L["디버프 표시"           ], L["<이름표 위쪽 디버프 Icon 표시>"                                    ], L["사용여부를 선택합니다."]);
    CreateOptionCheckButton(IFOUIConfig, 8, "ShowSpecialDeBuffTooltip"     , L["디버프Tooltip활성화"   ], L["디버프위에 마우스를 올렸을때 Tooltip 표시여부를 선택합니다."       ], "");
    CreateOptionCheckButton(IFOUIConfig, 9, "ShowPlayerBigBuff"            , L["플레이어 Big버프표시"  ], L["Player 체력바위에 버프 표시여부를 선택합니다."                     ], "");
    CreateOptionCheckButton(IFOUIConfig,10, "ReLocateGameToolTip"          , L["툴팁위치이동 사용"     ], L["툴팁의 위치를 우측하단에서 우측중앙하단으로 이동할지를 선택합니다."], "");
    CreateOptionCheckButton(IFOUIConfig,11, "ShowFriendsSpecialBuff"       , L["아군 버프 표시여부"    ], L["<아군 버프 표시여부>"                                              ], L["디버깅용"]);
    CreateOptionCheckButton(IFOUIConfig,12, "ShowFriendsSpecialDeBuff"     , L["아군 디버프 표시여부"  ], L["<아군 디버프 표시여부>"                                            ], L["디버깅용"]);
    CreateOptionCheckButton(IFOUIConfig,13, "ShowCoordinate"               , L["좌표보기 표시여부"     ], L["<좌표보기 표시여부>"                                               ], L["Reload 필요"]);
    CreateOptionCheckButton(IFOUIConfig,14, "ShowOnlyPlayerDeBuff"         , L["내 디버프만 보기"      ], L["<내가 건 디버프만 보기여부>"                                       ], L["내가 건 디버프만 보고싶을때 선택합니다."]);
    CreateOptionCheckButton(IFOUIConfig,15, "ShowCastingBar"               , L["캐스팅바 보기"         ], L["<캐스팅바 보기>"                                                   ], L["마우스 오버, 대상의 시전바를 생성합니다."]);
    CreateOptionCheckButton(IFOUIConfig,16, "ShowCastingTooltip"           , L["캐스팅 툴팁 보기"      ], L["<캐스팅 툴팁 보기>"                                                ], L["대상의 캐스팅 스킬의 툴팁을 생성합니다."]);
    CreateOptionCheckButton(IFOUIConfig,17, "AutoHideCastingTooltip"       , L["캐스팅 툴팁 자동숨기기"], L["<캐스팅 툴팁 자동숨기기>"                                          ], L["캐스팅 툴팁이 15초후 사라집니다."]);
    CreateOptionCheckButton(IFOUIConfig,18, "ShowRaidTargetMarker"         , L["타켓 징표 보기"        ], L["타켓 징표 표시여부를 선택합니다."                                  ], "");
    CreateOptionCheckButton(IFOUIConfig,19, "ShowWorldMarker"              , L["바닥 징표 보기"        ], L["바닥 징표 표시여부를 선택합니다."                                  ], "");
    
    --Slider
    --CreateOptionSlider(frame, sliderIndex, key, lowValue, highValue, tooltipText, tooltipRequirement )
    CreateOptionSlider(IFOUIConfig, 1, "ICON_SIZE"                         ,   1,   50, L["(디)버프ICON 크기"            ], L["버프 및 디버프 아이콘의 사이즈"] );
    CreateOptionSlider(IFOUIConfig, 2, "NumberLimitSpecialBuff"            ,   1,   20, L["버프 최대ICON 갯수"           ], L["버프 최대ICON 갯수"]);
    CreateOptionSlider(IFOUIConfig, 3, "NumberLimitSpecialDeBuff"          ,   1,   20, L["디버프 최대ICON 갯수"         ], L["디버프 최대ICON 갯수"] );
    CreateOptionSlider(IFOUIConfig, 4, "MilliSecondNameplateUpdateDoration",  10, 1000, L["버프/디버프 갱신 시간간격(ms)"], L["값이 낮을수록 빠르지만, FPS에 영향을 줍니다.\n추천 : 155"] );


    --IFOUIConfig.sliderList[1]:ClearAllPoints();
    --IFOUIConfig.sliderList[1]:SetPoint("TOP", IFOUIConfig.reload, "BOTTOM", 0,  -30);
--

    --인터페이스옵션을 다시 열때 설정변수값 다시 읽어서 Control에 동기화
    -- ==> 인터페이스옵션창을 닫고 다시 열 경우는 refresh 함수를 호출하지만,
    --     인터페이스옵션창에서 다른 애드온설정으로 갔다가 다시 돌아올때 동작안함
    --     ==> OnShow 이벤트로 대체함
    --IFOUIConfig.refresh = LJDConfigUI.SyncVariable;
    IFOUIConfig:SetScript("OnShow", LJDConfigUI.SyncVariable);

    InterfaceOptions_AddCategory(IFOUIConfig);

end


